package se.umu.cs.www.kurser._5dv093.ws.assignment4;

import java.io.*;
import java.net.*;
import javax.xml.stream.*;
import org.apache.axiom.om.*;
import org.apache.axis2.*;
import org.apache.axis2.addressing.*;
import org.apache.axis2.client.*;

public class Client
{
  private static final String DEFAULT_URL =
    "http://localhost:8080/axis2/services/assignment4";


  //---------------------------------------------------------
  //---------------------------------------------------------
  private static String toString (OMElement element)
  {
    try
    {
      java.io.StringWriter writer = new java.io.StringWriter();
      XMLOutputFactory factory = XMLOutputFactory.newInstance();
      element.serialize(factory.createXMLStreamWriter(writer));
      writer.flush();
      return writer.toString();
    }
    catch (Exception e)
    {
      return "[unable to transform XML element to string]";
    }
  }

  //---------------------------------------------------------
  public static void main (String args[])
  {
    try
    {
      final String service =
        "http://www.cs.umu.se/kurser/5DV093/ws/assignment4/";
      final String url =
        (args.length > 0) ? args[0] : DEFAULT_URL;

      System.out.println("URL: " + url);

      // create an Axiom factory
      OMFactory factory = OMAbstractFactory.getOMFactory();

      // create a service namespace
      // TODO: select service method to call
      OMNamespace namespace = factory.createOMNamespace(service,"ping");

      // create a request
      // TODO: select request method
      OMElement request = factory.createOMElement("PingRequest",namespace);

      // TODO: fill request object with XML data for your request

      // a way to print the generated XML (for debug purposes)
      //      System.out.println("XML: " + toString(request));

      // configure connection
      Options options = new Options();
      options.setTo(new EndpointReference(url));
      options.setTransportInProtocol(Constants.TRANSPORT_HTTP);
      options.setAction(url);

      // create a client
      ServiceClient client = new ServiceClient();
      client.setOptions(options);
      OMElement response = client.sendReceive(request);

      // parse and echo response
      System.out.println("RESPONSE:");
      System.out.println(toString(response));
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
}
